/***********************************************************************
*
*  FILE        : TestGNURXmacl.c
*  DATE        : 2019-10-13
*  DESCRIPTION : Main Program
*
*  NOTE:THIS IS A TYPICAL EXAMPLE.
*
***********************************************************************/
#include "r_smc_entry.h"

/* This code is obtained from:
 * e2studio_v760/internal/projectgen/rx/Generate/CCRXConversion/inc/CCRXmachine.h
*/
static __inline__ long __macl(short* data1, short* data2, unsigned long count)
{
  signed long register *ldata1 = (signed long *)data1;
  signed long register *ldata2 = (signed long *)data2;
  /* this is much more then an "intrinsic", no inline asm because of loop */
  /* will implement this.. interesting function as described in ccrx manual */
  __builtin_rx_mullo(0, 0);
  while (count > 1)
  {
    __builtin_rx_maclo(*ldata1, *ldata2);
    __builtin_rx_machi(*ldata1, *ldata2);
    ldata1++;
    ldata2++;
    count -= 2;
  }
  #ifdef __RX_BIG_ENDIAN__
  if (count != 0) __builtin_rx_machi(*ldata1, *ldata2);
  #else
  if (count != 0) __builtin_rx_maclo(*ldata1, *ldata2);
  #endif
  return __builtin_rx_mvfacmi();
}

void main(void);

short data1[4] = {-1, -2, -3};
short data2[4] = {-1, -2, -3};

long result;

void main(void)
{
  nop();
  result = __macl(data1, data2, 3);
  nop();
  result = R_BSP_MACL(data1, data2, 3);
  nop();
  for(;;);
}
